<template>
  <div v-if="!carousel">
    <div v-if="isMobile" class="relative popular-match-card-mobile">
      <div class="background-left"></div>
      <div class="background-right"></div>
      <div class="match-header">
        <span class="match-title">{{ popularMatch.LeagueName }}</span>
        <span class="match-date">{{ popularMatch.KickOffTimeForDisplay }}</span>
      </div>
      <hr class="line-under-header" />
      <div class="w-auto match-content">
        <div class="flex justify-center w-full px-2">
          <div class="flex items-center w-[112px] h-[42px]">
            <div class="w-[36px] h-[36px]">
              <img
                v-lazy="popularMatch.HomeTeamIconUrl"
                class="h-full max-w-full"
                alt="home"
              />
            </div>
            <div class="w-[72px] pl-1">
              <div class="team-name">
                {{ popularMatch.HomeName }}
              </div>
              <div class="flex justify-between">
                <span class="fc-primary">{{
                  popularMatch.HandicapPointForDisplay
                }}</span>
                <span>{{ popularMatch.HandicapHomeOddsForDisplay }}</span>
              </div>
            </div>
          </div>
          <div class="flex items-center justify-center w-[84px] h-[41px]">
            <div class="text-center">
              <p class="match-result h-[19px]">
                {{ popularMatch.HomeScore }} : {{ popularMatch.AwayScore }}
              </p>
              <el-button
                iv
                class="match-card-btn"
                :disabled="isDisabled"
                @click="onBetNowClick"
              >
                <span class="--textBtn">
                  {{ $t("bet_now") }}
                </span>
              </el-button>
            </div>
          </div>
          <div class="flex items-center w-[112px] h-[42px]">
            <div class="flex flex-col pr-1">
              <div class="team-name">
                {{ popularMatch.AwayName }}
              </div>
              <div class="flex justify-between">
                <span class="fc-primary">
                  {{
                    Number(popularMatch.HandicapPointForDisplay * -1).toFixed(2)
                  }}
                </span>
                <span>
                  {{ popularMatch.HandicapAwayOddsForDisplay }}
                </span>
              </div>
            </div>
            <div class="w-[36px] h-[36px]">
              <img
                v-lazy="popularMatch.AwayTeamIconUrl"
                class="h-full max-w-full"
                alt="away"
              />
            </div>
          </div>
        </div>
      </div>
    </div>
    <div v-else class="flex custom-popular-match-card-desktop gap-2.5">
      <div v-for="(popularMatch, index) in popularMatch" :key="index">
        <div class="popular-match-card-desktop">
          <div class="background-left"></div>
          <div class="background-right"></div>
          <div class="match-header">
            <div class="match-title">{{ popularMatch.LeagueName }}</div>
            <div class="match-date">
              {{ popularMatch.KickOffTimeForDisplay }}
            </div>
          </div>
          <div class="match-content">
            <div class="flex flex-col items-center side-logo">
              <div class="w-[60px] h-[60px]">
                <img
                  v-lazy="popularMatch.HomeTeamIconUrl"
                  class="h-full max-w-full"
                  alt="home"
                />
              </div>
              <p class="team-name">{{ popularMatch.HomeName }}</p>
              <p>
                <span class="blue_num">{{
                  popularMatch.HandicapPointForDisplay
                }}</span
                >{{ popularMatch.HandicapHomeOddsForDisplay }}
              </p>
            </div>
            <div
              class="w-[108px] flex flex-col items-center justify-center mt-9"
            >
              <div class="match-result">
                {{ popularMatch.HomeScore }} : {{ popularMatch.AwayScore }}
              </div>
              <el-button
                type="button"
                class="cursor-pointer match-card-btn"
                :disabled="isDisabled"
                @click="onBetNowClick"
              >
                <span class="--textBtn">{{ $t("bet_now") }}</span>
              </el-button>
            </div>
            <div class="flex flex-col items-center side-logo">
              <div class="w-[60px] h-[60px]">
                <img
                  v-lazy="popularMatch.AwayTeamIconUrl"
                  class="h-full max-w-full"
                  alt="away"
                />
              </div>
              <p class="team-name">{{ popularMatch.AwayName }}</p>
              <p>
                <span class="blue_num">
                  {{
                    Number(popularMatch.HandicapPointForDisplay * -1).toFixed(2)
                  }}
                </span>
                {{ popularMatch.HandicapAwayOddsForDisplay }}
              </p>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div v-else>
    <div class="w-[444px] h-[208px] flex justify-center justify-between">
      <div class="flex items-center justify-center" @click="arrowClick('perv')">
        <div class="btn-prev-carousel">
          <div class="play"></div>
        </div>
      </div>
      <el-carousel
        ref="arrowCard"
        class="w-[360px]"
        :autoplay="true"
        :interval="4000"
        trigger="click"
        arrow="never"
      >
        <el-carousel-item
          v-for="(popularMatch, index) in popularMatch"
          :key="index"
        >
          <div class="popular-match-card-desktop">
            <div class="background-left"></div>
            <div class="background-right"></div>
            <div class="match-header">
              <div class="match-title">{{ popularMatch.LeagueName }}</div>
              <div class="match-date">
                {{ popularMatch.KickOffTimeForDisplay }}
              </div>
            </div>
            <div class="match-content">
              <div class="flex flex-col items-center side-logo">
                <div class="w-[60px] h-[60px]">
                  <img
                    v-lazy="popularMatch.HomeTeamIconUrl"
                    class="h-full max-w-full"
                    alt="home"
                  />
                </div>
                <p class="team-name">{{ popularMatch.HomeName }}</p>
                <p>
                  <span class="blue_num">{{
                    popularMatch.HandicapPointForDisplay
                  }}</span
                  >{{ popularMatch.HandicapHomeOddsForDisplay }}
                </p>
              </div>
              <div
                class="w-[108px] flex flex-col items-center justify-center mt-9 mb-3.5"
              >
                <div class="match-result">
                  {{ popularMatch.HomeScore }} : {{ popularMatch.AwayScore }}
                </div>
                <el-button
                  type="button"
                  class="cursor-pointer match-card-btn"
                  :disabled="isDisabled"
                  @click="onBetNowClick"
                >
                  <span class="--textBtn">{{ $t("bet_now") }}</span>
                </el-button>
              </div>
              <div class="flex flex-col items-center side-logo">
                <div class="w-[60px] h-[60px]">
                  <img
                    v-lazy="popularMatch.AwayTeamIconUrl"
                    class="h-full max-w-full"
                    alt="away"
                  />
                </div>
                <p class="team-name">{{ popularMatch.AwayName }}</p>
                <p>
                  <span class="blue_num">
                    {{
                      Number(popularMatch.HandicapPointForDisplay * -1).toFixed(
                        2
                      )
                    }}
                  </span>
                  {{ popularMatch.HandicapAwayOddsForDisplay }}
                </p>
              </div>
            </div>
          </div>
        </el-carousel-item>
      </el-carousel>
      <div
        class="relative flex items-center justify-center"
        @click="arrowClick('next')"
      >
        <div class="btn-next-carousel">
          <div class="play"></div>
        </div>
      </div>
    </div>
  </div>
</template>
<script lang="ts">
import { defineComponent, PropType, ref } from "vue";
import {
  ILoginByMatchIdRequest,
  IRecommendMatch,
} from "@/models/theme/popular_match/popularMatch";
import { store } from "@/store";
import apis from "@/utils/apis";
import EnumApiErrorCode from "@/models/enums/enumApiErrorCode";
import { useLanguageComponent } from "@/composables/useTheme";
import commonHelper from "@/utils/commonHelper";

const { getAssetImage } = commonHelper;
export default defineComponent({
  name: "PopularMatchCard",
  props: {
    popularMatch: {
      type: Object as PropType<IRecommendMatch>,
      required: true,
    },
    backgroundCard: {
      type: String,
      default: () =>
        getAssetImage("assets/theme/common/popular_match/light_card_bg.png"),
    },
    isMobile: {
      type: Boolean,
      default: () => false,
    },
    carousel: {
      type: Boolean,
      default: () => false,
    },
  },
  setup(props) {
    const router = useRouter();
    const { defaultLanguage } = useLanguageComponent();
    const isDisabled = ref(false);
    const onBetNowClick = async () => {
      if (store.state.auth) {
        isDisabled.value = true;
        const request: ILoginByMatchIdRequest = {
          MatchId: props.popularMatch.MatchId,
          IsFromMobile: props.isMobile,
          FromUrl: window.location.href,
          Lang: defaultLanguage,
          OnlineId: Number(localStorage.getItem("onlineId") ?? 0),
        };
        const response = await apis.loginByMatchId(request);
        if (response.isSuccessful) {
          router.push({
            path: "/bet-now",
            query: { tab: "Sports", url: response.Data.Url },
          });
        }
      } else {
        if (useIsDesktop()) {
          router.push("/login");
        }
        store.commit("updateLoginDialog", !store.state.showLoginDialog);
      }
    };
    const bgLeft = `url(${getAssetImage(
      "assets/theme/common/popular_match/frame_123.png"
    )})`;
    const bgRight = `url(${getAssetImage(
      "assets/theme/common/popular_match/frame_124.png"
    )}`;
    const arrowCard = ref();
    const arrowClick = (val: string) => {
      if (val === "next") {
        arrowCard.value.next();
      } else arrowCard.value.prev();
    };
    return {
      onBetNowClick,
      isDisabled,
      bgLeft,
      bgRight,
      arrowClick,
      arrowCard,
      getAssetImage,
    };
  },
});
</script>
<style lang="scss">
.popular-match-card-mobile {
  box-sizing: border-box;
  width: 328px;
  height: auto;
  background: var(--background5);
  border: 1px solid var(--border);
  box-shadow: 0px 4px 4px rgba(0, 0, 0, 0.25);
  border-radius: 8px;
  font-family: Roboto, sans-serif;
  font-size: 12px;
  line-height: 14px;
  font-weight: 400;
  font-style: normal;
  color: var(--text2);
  z-index: 0;
  .background-left {
    width: 84px;
    height: 84px;
    background-image: v-bind("bgLeft");
    position: absolute;
    top: 0;
    left: 0;
    background-size: contain;
    z-index: -1;
    opacity: 0.6;
  }
  .background-right {
    width: 84px;
    height: 84px;
    background-image: v-bind("bgRight");
    position: absolute;
    top: 0;
    right: 0;
    background-size: contain;
    z-index: -1;
    opacity: 0.6;
  }
  .line-under-header {
    border: 1px solid var(--border);
    margin: 8px;
    width: 312px;
    opacity: 50%;
  }
  .match-header {
    text-align: center;
    padding-top: 8px;
    .match-title {
      color: var(--text5);
      margin-right: 6px;
    }
    .match-date {
      color: var(--primary);
    }
  }
  .match-content {
    .team-name {
      height: 28px;
      width: 72px;
      display: flex;
      align-items: center;
      justify-content: center;
    }
    .blue_num {
      color: var(--primary);
      margin-right: 30%;
    }
    .match-result {
      font-size: 16px;
      font-weight: 900;
      line-height: 19px;
      color: var(--text5);
    }
    .match-card-btn {
      font-weight: 700;
      color: var(--primary);
      padding-top: 4px;
      background-color: transparent;
      border: none;
      font-size: 12px;
      line-height: 14px;
    }
  }
}
.popular-match-card-desktop {
  position: relative;
  background: var(--background5);
  border: 2px solid var(--background1);
  border-radius: 20px 0px;
  font-family: Roboto, sans-serif;
  font-size: 14px;
  line-height: 16px;
  font-style: normal;
  font-weight: 400;
  color: var(--text5);
  margin-right: 9px;
  z-index: 0;
  // width: 394px;
  height: 184px;
  &:last-child {
    margin-right: 0px;
  }
  .background-left {
    width: 184px;
    height: 184px;
    background-image: v-bind("bgLeft");
    position: absolute;
    top: 0;
    left: 0;
    background-size: contain;
    z-index: -1;
  }
  .background-right {
    width: 184px;
    height: 184px;
    background-image: v-bind("bgRight");
    position: absolute;
    bottom: 0;
    right: 0;
    background-size: contain;
    z-index: -1;
  }
  .match-header {
    text-align: center;
    .match-title {
      padding-top: 12px;
    }
    .match-date {
      color: var(--primary);
      font-weight: 700;
      margin-top: 4px;
    }
  }
  .match-result {
    color: var(--text5);
    font-weight: 900;
    font-size: 40px;
    text-align: center;
    width: 86px;
    height: 47px;
  }
  .match-content {
    display: flex;
    padding-left: 6px;
    justify-content: space-between;
    .team-name {
      font-size: 12px;
      display: flex;
      align-items: center;
      justify-content: center;
      width: 100px;
      height: 32px;
      line-height: 14px;
    }

    .side-logo {
      text-align: center;
      width: 35%;
    }

    .blue_num {
      color: var(--primary);
      padding-right: 12px;
    }
  }
  .match-card-btn {
    &.el-button {
      border: none;
    }
    &.is-disabled {
      cursor: default;
    }
    color: var(--primary);
    width: 108px;
    height: 38px;
    background: var(--primary);
    box-shadow: inset -2px -2px 2px rgba(0, 0, 0, 0.25),
      inset 2px 2px 2px rgba(255, 255, 255, 0.25);
    border-radius: 8px 0px;
    position: relative;
    z-index: 1;
    text-align: center;
    span {
      width: 68px;
      color: var(--textBtn);
      font-size: 12px;
      font-weight: 900;
    }
  }
}
.popular-match {
  .custom-popular-match-card-desktop {
    min-width: 1200px;
    margin: 50px 20px 10px 0px;
    align-items: center;
    justify-content: center;
    overflow: hidden;
  }
}
[layout="cool88"] {
  .match-result {
    color: var(--text5);
    font-weight: 900;
    font-size: 40px;
    text-align: center;
    width: 86px;
    height: 38px;
  }
  .match-header {
    text-align: center;
    .match-title {
      padding-top: 10px;
    }
    .match-date {
      color: var(--primary);
      font-weight: 700;
      margin-top: 4px;
    }
  }
  .popular-match {
    .el-carousel {
      height: 176px;
      position: unset;
    }
    .el-carousel__indicators--horizontal {
      margin-bottom: -10px;
    }
  }
  .el-carousel {
    border-radius: 20px 0 20px 0;
    .el-carousel__container {
      height: 175px;
    }
  }
  .btn-next-carousel,
  .btn-prev-carousel {
    background: var(--background5);
    height: 30px;
    width: 30px;
    border-radius: 50%;
    border: 3px solid var(--background1);
    bottom: 0%;
    box-shadow: 0px 4px 4px rgba(0, 0, 0, 0.25);
    display: flex;
    justify-content: center;
    align-items: center;
    cursor: pointer;
  }
  .btn-next-carousel {
    .play {
      border-color: transparent transparent transparent var(--primary);
      border-width: 6px 0 6px 12px;
      margin-left: 3px;
    }
  }

  .btn-prev-carousel {
    .play {
      border-color: transparent transparent transparent var(--primary);
      border-width: 6px 0 6px 12px;
      margin-right: 3px;
      transform: rotate(180deg);
    }
  }
}
</style>
